## uwsgi 1.9.13

=== debian/changelog ===
uwsgi (1.9.13-4) unstable; urgency=low

  * Remove hardcoded phpapi-20100525 dependency. (Closes: #715472)
  * Build uwsgi-plugin-v8 and build depend on libv8-dev only on
    amd64 armel armhf i386 architectures. (Closes: #715473)
  * Remove apache2 and apache2-api-20120211 dependencies for
    libapache2-mod-proxy-uwsgi, libapache2-mod-uwsgi and
    libapache2-mod-ruwsgi. (Closes: #715485)
  * Add ${uwsgi:apache2:Depends} substvar to reference Apache2 API version.
  * Add ${uwsgi:php:Depends} substvar to reference PHP API version.
  * Add libphp5-embed as a dependency for uwsgi-plugin-php.

 -- Janos Guljas <janos@debian.org>  Wed, 10 Jul 2013 22:23:20 +0200

uwsgi (1.9.13-3) unstable; urgency=low

  * debian/uwsgi-core.install.
    - Include alarm_speech, coroae and pem plugins into the uwsgi-core
      package.

 -- Janos Guljas <janos@debian.org>  Tue, 09 Jul 2013 02:24:32 +0200

uwsgi (1.9.13-2) unstable; urgency=low

  * Move plugins from binary packges to uwsgi-core package as they have
    dependencies with priority set to required:
    - alarm_speech
    - coroae
    - pam

 -- Janos Guljas <janos@debian.org>  Tue, 09 Jul 2013 01:56:41 +0200

uwsgi (1.9.13-1) unstable; urgency=low

  * New upstream release.
  * Update dependencies to build with Apache 2.4. (Closes: #709468)
    - Remove apache2-threaded-dev.
    - Add apache2-dev (>> 2.4~).
    - Depend lbapache2-mod-proxy-uwsgi, ibapache2-mod-uwsgi and
       libapache2-mod-ruwsgi on apache2-api-20120211.
  * Update postinst and prerm scripts to use apache2-maintscript-helper.
  * Add debian/patches/emperor-pg-fix-cflags.patch.
    - Remove -Wformat-security flag to fix build error
  * debian/uwsgi-core.docs:
    - Remove uwsgi_API.txt.

 -- Janos Guljas <janos@debian.org>  Mon, 08 Jul 2013 14:06:14 +0200

uwsgi (1.9.11-1) unstable; urgency=low

  * New upstream release.
  * Upstream version does not contain minfied JavaScript files:
    - Drop dfsg sufix from version.
    - Remove get-orig-source target from debian/rules.
  * Update debian/copyright:
    - Remove references to removed files lib/rbtree.c, lib/rbtree.h and
      nginx/ngx_http_uwsgi_module.c.
    - Added copyrights for core/rb_timers.c and core/hash.c.
    - Updated copyright years.
  * debian/rules:
    - Change UWSGICONFIG_JVM_INCPATH to fix jvm plugin build.
  * Patch Python plugin to remove assignments to environment variable
    LD_RUN_PATH which leads to setting RPATH in compiled binary/shared library:
    python-plugin_remove_assignments_to_LD_RUN_PATH.patch.
  * debian/pathces/fix-php-ldflags.patch
    - Include php5-embed ld library path when building PHP plugin.
  * debian/patches/remove-php-libs.patch
    - Remove PHP libraries when building PHP plugin.
  * Update patches to apply cleanly:
    - fix-reload-process-name.patch
    - fix-php-ldflags.patch
    - 000000_02_remove_assignments_to_LD_RUN_PATH.patch
  * Remove no longer needed patches:
    - 110515_01_add_overriding_of_JVM_PATH_into_buildscript_of_jwsgi_plugin.patch
    - 000000_03_strip_versions_from_jQuery_scripts_links_in_uwsgicc_templates.patch
    - remove-pg_config_cflags-in-probepg.patch
  * Update lintian-overrides for jwsgi and jvm plugins.
  * New binary package uwsgi-emperor. (Closes: #660212)
  * New binary package uwsgi-plugin-php. (Closes: #699174)
    - New Build-Depends libphp5-embed, php5-dev, libonig-dev, libdb-dev,
      libqdbm-dev and libbz2-dev.
  * New binary package uwsgi-plugin-alarm-curl:
    - New Build-Depends libcurl4-openssl-dev.
    - Add alarm option to buildconf/uwsgi-core.ini.
    - Set pcre option to true in: buildconf/uwsgi-core.ini.
  * New binary package uwsgi-plugin-alarm-xmpp:
     - New Build-Depends libgloox-dev.
  * New binary package uwsgi-plugin-pam:
    - New Build-Depends libpam0g-dev.
  * New binary package uwsgi-plugin-router-access:
    - New Build-Depends libwrap0-dev.
    - Add routing option to buildconf/uwsgi-core.ini.
  * New binary package uwsgi-plugin-alarm-speech:
    - New Build-Depends libgnustep-base-dev and libgnustep-gui-dev.
    - Add debian/patches/alarm_speech-flags.patch
  * New binary package uwsgi-plugin-coroae:
    - New Build-Depends libcoro-perl.
  * New binary package uwsgi-plugin-geoip:
    - New Build-Depends libgeoip-dev.
  * New binary package uwsgi-plugin-v8:
    - New Build-Depends libv8-dev.
  * New binary package uwsgi-plugin-xslt:
    - New Build-Depends libxslt1-dev.
  * New binary packages libapache2-mod-proxy-uwsgi and
    libapache2-mod-proxy-uwsgi-dbg.
  * Add plugins to uwsgi-core package:
    - cheaper_backlog2
    - cheaper_busyness
    - clock_monothonic
    - clock_realtime
    - corerouter
    - emperor_amqp
    - logfile
    - notfound
    - rawrouter
    - redislog
    - router_basicauth
    - router_cache
    - router_http
    - router_memcached
    - router_redirect
    - router_rewrite
    - router_uwsgi
    - spooler
    - ssi
    - sslrouter
    - stats_pusher_statsd
    - transformation_gzip
    - transformation_tofile
    - transformation_toupper
    - zergpool
    - logfile
  * Move plugins from binary packges to uwsgi-core package as they do not have
    additional dependencies:
    - admin
    - cache
    - carbon
    - cgi
    - echo
    - emperor_zeromq
    - fastrouter
    - http
    - logsocket
    - nagios
    - ping
    - router_static
    - rpc
    - rrdtool
    - rsyslog
    - signal
    - symcall
    - syslog
    - ugreen
  * New plugins:
    - uwsgi-plugin-curl-cron
    - uwsgi-plugin-emperor-pg
    - uwsgi-plugin-ldap
    - uwsgi-plugin-sqlite3
    - uwsgi-plugin-systemd-logger
  * Remove no longer provided plugins:
    - uwsgi-plugin-probeconnect
    - uwsgi-plugin-probepg
  * Remove no longer provided packages:
    - python-uwsgicc
    - python-django-uwsgi-admin
  * Remove plugins which are moved to uwsgi-core package:
    - uwsgi-plugin-admin
    - uwsgi-plugin-cache
    - uwsgi-plugin-carbon
    - uwsgi-plugin-cgi
    - uwsgi-plugin-echo
    - uwsgi-plugin-emperor-zeromq


=== debian/control ===
Source: uwsgi
Section: web
Priority: extra
Maintainer: Janos Guljas <janos@debian.org>
Build-Depends:
 cdbs,
 debhelper (>= 8),
 apache2-dev (>> 2.4~),
 erlang-dev,
 help2man,
 javahelper,
 libapr1-dev,
 libaprutil1-dev,
 libjansson-dev,
 libldap2-dev,
 liblua5.1-0-dev,
 libperl-dev,
 libpq-dev,
 libcurl4-openssl-dev,
 libgloox-dev,
 libpam0g-dev,
 libsqlite3-dev,
 libxml2-dev,
 libyaml-dev,
 libzmq-dev,
 libphp5-embed,
 php5-dev,
 libonig-dev,
 libdb-dev,
 libqdbm-dev,
 libbz2-dev,
 libwrap0-dev,
 libgnustep-gui-dev,
 libgnustep-base-dev,
 libcoro-perl,
 libgeoip-dev,
 libv8-dev [amd64 armel armhf i386],
 libxslt1-dev,
 pkg-config,
 python,
 python-all-dev,
 python-greenlet-dev [amd64 i386 mips powerpc s390],
 python3-all-dev,
 openjdk-6-jdk,
 openjdk-7-jdk,
 ruby1.8,
 ruby1.8-dev,
 ruby1.9.1,
 ruby1.9.1-dev,
 uuid-dev
Standards-Version: 3.9.4
Homepage: http://projects.unbit.it/uwsgi/
Vcs-Git: git://anonscm.debian.org/collab-maint/uwsgi.git
Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/uwsgi.git

Package: uwsgi
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, uwsgi-core (= ${binary:Version}),
 lsb-base, initscripts (>= 2.88dsf-13.3)
Recommends: sqlite3
Description: fast, self-healing application container server
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It uses the uwsgi protocol for all the networking/interprocess communications.
 .
 uWSGI can be run in preforking, threaded, asynchronous/evented modes and
 supports various forms of green threads/coroutines (such as uGreen, Greenlet,
 Fiber). uWSGI provides several methods of configuration: via command line,
 via environment variables, via XML, INI, YAML configuration files, via LDAP
 and more.
 .
 On top of all this, it is designed to be fully modular. This means that
 different plugins can be used in order to add compatibility with tons of
 different technology on top of the same core.
 .
 This package depends on uWSGI core binary and installs:
   * init.d script for running uWSGI daemon(s) with options defined in custom
     user-created configuration files
   * infrastructure for running daemons (like common locations of communication
     sockets, logs)

Package: uwsgi-dbg
Architecture: any
Section: debug
Depends: ${misc:Depends}, uwsgi-core (= ${binary:Version})
Suggests: uwsgi-plugins-all
Description: debugging symbols for uWSGI server and it's plugins
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 .
 This package contains the debug symbols for uWSGI core binary and plugins.
 Install this package if you need to debug such a program or if you need a
 useful backtrace of a crash.

Package: uwsgi-core
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: nginx-full | cherokee | libapache2-mod-proxy-uwsgi | libapache2-mod-uwsgi | libapache2-mod-ruwsgi,
 uwsgi-plugins-all, uwsgi-extra
Replaces: wsgi-plugin-admin,
 uwsgi-plugin-cache,
 uwsgi-plugin-carbon,
 uwsgi-plugin-cgi,
 uwsgi-plugin-echo,
 uwsgi-plugin-emperor-zeromq,
 uwsgi-plugin-fastrouter,
 uwsgi-plugin-http,
 uwsgi-plugin-logsocket,
 uwsgi-plugin-nagios,
 uwsgi-plugin-ping,
 uwsgi-plugin-router-static,
 uwsgi-plugin-rpc,
 uwsgi-plugin-rrdtool,
 uwsgi-plugin-rsyslog,
 uwsgi-plugin-signal,
 uwsgi-plugin-symcall,
 uwsgi-plugin-syslog,
 uwsgi-plugin-ugreen
Conflicts: wsgi-plugin-admin,
 uwsgi-plugin-cache,
 uwsgi-plugin-carbon,
 uwsgi-plugin-cgi,
 uwsgi-plugin-echo,
 uwsgi-plugin-emperor-zeromq,
 uwsgi-plugin-fastrouter,
 uwsgi-plugin-http,
 uwsgi-plugin-logsocket,
 uwsgi-plugin-nagios,
 uwsgi-plugin-ping,
 uwsgi-plugin-router-static,
 uwsgi-plugin-rpc,
 uwsgi-plugin-rrdtool,
 uwsgi-plugin-rsyslog,
 uwsgi-plugin-signal,
 uwsgi-plugin-symcall,
 uwsgi-plugin-syslog,
 uwsgi-plugin-ugreen
Description: fast, self-healing application container server (core)
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It uses the uwsgi protocol for all the networking/interprocess communications.
 .
 uWSGI can be run in preforking, threaded, asynchronous/evented modes and
 supports various forms of green threads/coroutines (such as uGreen, Greenlet,
 Fiber). uWSGI provides several methods of configuration: via command line,
 via environment variables, via XML, INI, YAML configuration files, via LDAP
 and more.
 .
 On top of all this, it is designed to be fully modular. This means that
 different plugins can be used in order to add compatibility with tons of
 different technology on top of the same core.
 .
 This package provides:
   * executable uWSGI core binary (built without any embedded plugins)
   * uWSGI usage examples
   * uWSGI test suite
   * plugins that do not require additional dependencies:
    - admin
    - alarm_speech
    - cache
    - carbon
    - cgi
    - cheaper_backlog2
    - cheaper_busyness
    - clock_monothonic
    - clock_realtime
    - corerouter
    - coroae
    - echo
    - emperor_amqp
    - emperor_zeromq
    - fastrouter
    - http
    - logfile
    - logfile
    - logsocket
    - nagios
    - notfound
    - pam
    - ping
    - rawrouter
    - redislog
    - router_basicauth
    - router_cache
    - router_http
    - router_memcached
    - router_redirect
    - router_rewrite
    - router_static
    - router_uwsgi
    - rpc
    - rrdtool
    - rsyslog
    - signal
    - spooler
    - ssi
    - sslrouter
    - stats_pusher_statsd
    - symcall
    - syslog
    - transformation_gzip
    - transformation_tofile
    - transformation_toupper
    - ugreen
    - zergpool

Package: uwsgi-emperor
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, uwsgi-core (= ${binary:Version}),
 lsb-base, initscripts (>= 2.88dsf-13.3)
Description: fast, self-healing application container server (emperor scripts)
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It uses the uwsgi protocol for all the networking/interprocess communications.
 .
 uWSGI can be run in preforking, threaded, asynchronous/evented modes and
 supports various forms of green threads/coroutines (such as uGreen, Greenlet,
 Fiber). uWSGI provides several methods of configuration: via command line,
 via environment variables, via XML, INI, YAML configuration files, via LDAP
 and more.
 .
 On top of all this, it is designed to be fully modular. This means that
 different plugins can be used in order to add compatibility with tons of
 different technology on top of the same core.
 .
 This package depends on uWSGI core binary and installs:
   * init.d script for running uWSGI Emperor daemon with options defined in
     custom user-created configuration files
   * basic configuration for running uWSGI Emperor daemon

Package: uwsgi-plugins-all
Architecture: any
Depends: ${misc:Depends},
 uwsgi-infrastructure-plugins (= ${binary:Version}),
 uwsgi-app-integration-plugins (= ${binary:Version}),
 uwsgi-plugin-fiber (= ${binary:Version}),
 uwsgi-plugin-greenlet-python (= ${binary:Version})
   [amd64 i386 mips powerpc s390],
 uwsgi-plugin-php (= ${binary:Version}),
 uwsgi-plugin-pyerl-python (= ${binary:Version}),
 uwsgi-plugin-pyerl-python3 (= ${binary:Version})
Description: all available plugins for uWSGI
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It is designed to be fully modular. This means that different plugins can be
 used in order to add compatibility with tons of different technology on top of
 the same core.
 .
 This dependency package provides all available plugins for uWSGI:
   * infrastructure plugins (HTTP serving, RPC, etc.)
   * plugins for integration of uWSGI and application (PSGI, Rack, WSGI,
     etc.)
   * fiber loop engine, greenlet (Python), pyerl (Python/Python 3)

Package: uwsgi-infrastructure-plugins
Architecture: any
Depends: ${misc:Depends},
 uwsgi-plugin-alarm-curl (= ${binary:Version}),
 uwsgi-plugin-alarm-xmpp (= ${binary:Version}),
 uwsgi-plugin-curl-cron (= ${binary:Version}),
 uwsgi-plugin-emperor-pg (= ${binary:Version}),
 uwsgi-plugin-graylog2 (= ${binary:Version}),
 uwsgi-plugin-geoip (= ${binary:Version}),
 uwsgi-plugin-ldap (= ${binary:Version}),
 uwsgi-plugin-router-access (= ${binary:Version}),
 uwsgi-plugin-sqlite3 (= ${binary:Version}),
 uwsgi-plugin-xslt (= ${binary:Version})
Description: infrastructure plugins for uWSGI
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It is designed to be fully modular. This means that different plugins can be
 used in order to add compatibility with tons of different technology on top of
 the same core.
 .
 This dependency package provides infrastructure plugins for uWSGI:
   * alarm curl
   * alarm XMPP
   * curl cron
   * PostgreSQL emperor
   * graylog2
   * GeoIP
   * LDAP
   * router access
   * sqlite3
   * XSLT request

Package: uwsgi-app-integration-plugins
Architecture: any
Depends: ${misc:Depends},
 uwsgi-plugin-erlang (= ${binary:Version}),
 uwsgi-plugin-jvm-openjdk-6 (= ${binary:Version}),
 uwsgi-plugin-jvm-openjdk-7 (= ${binary:Version}),
 uwsgi-plugin-jwsgi-openjdk-6 (= ${binary:Version}),
 uwsgi-plugin-jwsgi-openjdk-7 (= ${binary:Version}),
 uwsgi-plugin-lua5.1 (= ${binary:Version}),
 uwsgi-plugin-php (= ${binary:Version}),
 uwsgi-plugin-psgi (= ${binary:Version}),
 uwsgi-plugin-python (= ${binary:Version}),
 uwsgi-plugin-python3 (= ${binary:Version}),
 uwsgi-plugin-rack-ruby1.8 (= ${binary:Version}),
 uwsgi-plugin-rack-ruby1.9.1 (= ${binary:Version}),
 uwsgi-plugin-v8 (= ${binary:Version}) [amd64 armel armhf i386]
Description: plugins for integration of uWSGI and application
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It is designed to be fully modular. This means that different plugins can be
 used in order to add compatibility with tons of different technology on top of
 the same core.
 .
 This dependency package provides plugins for integration of uWSGI and
 application:
   * Erlang
   * Java (OpenJDK 6 and 7)
   * JWSGI (OpenJDK 6 and 7)
   * Lua WSAPI (Lua 5.1)
   * PHP
   * Perl PSGI
   * Python WSGI (Python/Python 3)
   * Rack (Ruby 1.8/Ruby 1.9.1)
   * V8

Package: uwsgi-plugin-alarm-curl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, uwsgi-core (= ${binary:Version})
Description: Alarm curl plugin for uWSGI
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It is designed to be fully modular. This means that different plugins can be
 used in order to add compatibility with tons of different technology on top of
 the same core.
 .
 This package provides alarm_curl plugin for uWSGI.

Package: uwsgi-plugin-alarm-xmpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, uwsgi-core (= ${binary:Version})
Description: Alarm XMPP plugin for uWSGI
 uWSGI presents a complete stack for networked/clustered web applications,
 implementing message/object passing, caching, RPC and process management.
 It is designed to be fully modular. This means that different plugins can be
 used in order to add compatibility with tons of different technology on top of
 the same core.
 .
 This package provides alarm_xmpp plugin for uWSGI.

Package: uwsgi-plugin-curl-cron
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, uwsgi-core (= ${binary:Version})
Description: curl cron plugin for uWSGI
 uWSGI presents a complete stack for networked/clustered web applications,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk

export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
export CFLAGS+=$(shell dpkg-buildflags --get CPPFLAGS)
export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)

# Common variables
# ================

PYTHON=/usr/bin/python
APXS2=/usr/bin/apxs2
APR_CONFIG=/usr/bin/apr-config
APU_CONFIG=/usr/bin/apu-config
UWSGI_BUILDER = $(CURDIR)/uwsgiconfig.py
APACHE2_API = $(shell perl -ne 'print $$1 if m/our\s+\$$API\s+=\s+"(.*)"/' < $(shell which dh_apache2))
PHP_API = $(shell php-config --phpapi)

DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Dotted versions of Python runtimes (like 'X.Y').
PYTHON_VERS_DOTTED=$(shell pyversions -vs)
PYTHON_DEFAULT_DOTTED=$(shell pyversions -dv)
PYTHON3_VERS_DOTTED=$(shell py3versions -vs)
PYTHON3_DEFAULT_DOTTED=$(shell py3versions -dv)

# Dotless versions of Python runtimes (like 'XY').
PYTHON_VERS=$(subst .,,$(PYTHON_VERS_DOTTED))
PYTHON_DEFAULT=$(subst .,,$(PYTHON_DEFAULT_DOTTED))
PYTHON3_VERS=$(subst .,,$(PYTHON3_VERS_DOTTED))
PYTHON3_DEFAULT=$(subst .,,$(PYTHON3_DEFAULT_DOTTED))

PYTHON_MAJOR_VER := 2
PYTHON3_MAJOR_VER := 3

# Standard directories, where dh_pythonX helper looking for Python modules.
# Note: path is provided in debhelper format (without leading slash).
PYTHON_DIST_PACKAGES_DIR = usr/lib/python$(PYTHON_DEFAULT_DOTTED)/dist-packages
PYTHON3_DIST_PACKAGES_DIR = usr/lib/python3/dist-packages

# Search in debian/control for packages with name $(1)% and extract % in list.
list_pkgname_suffixes = $(strip \
	$(shell \
		grep "^Package: $(1)" $(CURDIR)/debian/control \
		| sed 's/Package: $(1)//' \
	) \
)

# Transform plugin's package name to plugin's name:
# * delete dots
# * replace '-' with '_'
# * replace 'openjdk_6' with 'openjdk6'
# * replace 'openjdk_7' with 'openjdk7'
pkg_name_to_plugin_name = $(strip \
	$(subst openjdk_7,openjdk7,$(subst openjdk_6,openjdk6,$(subst -,_,$(subst .,,$(1)))) \
))

# List of plugins' packages names (without common prefix 'uwsgi-plugin-')
UWSGI_PLUGIN_PKGS_NAMES = $(call list_pkgname_suffixes,uwsgi-plugin-)

# List of plugins' names
UWSGI_PLUGINS_NAMES = $(call \
	pkg_name_to_plugin_name, $(UWSGI_PLUGIN_PKGS_NAMES))

UWSGI_PLUGINS_SRC_DIR = plugins

UWSGI_PLUGIN_PYTHON_PKG_KINDS = python python3

PARTICULARLY_BUILT_UWSGI_PLUGIN_PKGS = \
	$(UWSGI_PLUGIN_PYTHON_PKG_KINDS) \
	greenlet-python \
	jvm-openjdk-6 jwsgi-openjdk-6 \
	lua5.1 \
	jvm-openjdk-7 jwsgi-openjdk-7 \
	$(patsubst %,pyerl-%,$(UWSGI_PLUGIN_PYTHON_PKG_KINDS)) \
	rack-ruby1.8 rack-ruby1.9.1 fiber

ORDINARILY_BUILT_UWSGI_PLUGIN_PKGS := $(filter-out \
	$(PARTICULARLY_BUILT_UWSGI_PLUGIN_PKGS), $(UWSGI_PLUGIN_PKGS_NAMES))

# List of packaged Apache2 modules' names
LIBAPACHE2_MODS_NAMES = uwsgi ruwsgi proxy-uwsgi

libapache2mod_to_orig = $(subst -,_,$(subst ruwsgi,Ruwsgi,$(1)))

# List of templates to instantiate for each libapache2-mod-X package
# There is special-case template, not listed here: uwsgi.load
LIBAPACHE2_MOD_PKG_TEMPLATES = install postinst prerm

UWSGI_CORE_DOCS_STAGING_DIR = $(CURDIR)/debian/uwsgi-core-docs-staging

# Discards directory-part of target and returns substring after last '-'
# character
target_name_tail = $(lastword $(subst -, ,$(notdir $(1))))

# From something like:
#   $(call <...>, uwsgi-, $(UWSGI_PLUGIN_PYTHON_PKG_KINDS), .dirs)
# makes list:
#   $(CURDIR)/debian/uwsgi-python.dirs $(CURDIR)/debian/uwsgi-python3.dirs
files_instantiated_in_debian_dir = $(addprefix \
	$(CURDIR)/debian/$(strip $(1)), $(addsuffix $(strip $(3)), $(strip $(2))) \
)

# CDBS-specific variables
# =======================

DEB_COMPRESS_EXCLUDE_uwsgi-core = .ini .lua .pl .png .psgi .py .ru .ws .xml \
                                  .yml
DEB_COMPRESS_EXCLUDE_uwsgi-extra = .class .java .rb .c

DEB_DH_STRIP_ARGS_uwsgi-core := --dbg-package=uwsgi-dbg
$(foreach PLUGIN_PKG_NAME, $(UWSGI_PLUGIN_PKGS_NAMES), $(eval \
	DEB_DH_STRIP_ARGS_uwsgi-plugin-$(PLUGIN_PKG_NAME) := --dbg-package=uwsgi-dbg\
))

DEB_INSTALL_DOCS_ALL += $(DEB_SRCDIR)/CONTRIBUTORS

DEB_DH_SHLIBDEPS_ARGS_uwsgi-plugin-php = -l/usr/lib/php5 -- --ignore-missing-info

DEB_DH_GENCONTROL_ARGS_uwsgi-plugin-php = -- -Vuwsgi:php:Depends="phpapi-$(PHP_API)"

DEB_DH_GENCONTROL_ARGS_libapache2-mod-proxy-uwsgi = -- -Vuwsgi:apache2:Depends="apache2-api-$(APACHE2_API)"
DEB_DH_GENCONTROL_ARGS_libapache2-mod-uwsgi = -- -Vuwsgi:apache2:Depends="apache2-api-$(APACHE2_API)"
DEB_DH_GENCONTROL_ARGS_libapache2-mod-ruwsgi = -- -Vuwsgi:apache2:Depends="apache2-api-$(APACHE2_API)"

# Rules
# =====

clean::
	# uWSGI executable binaries
	$(RM) $(CURDIR)/uwsgi-core $(CURDIR)/uwsgi-core-local
	for PLUGIN_NAME in $(UWSGI_PLUGINS_NAMES); do \
		$(RM) $(CURDIR)/uwsgi_$${PLUGIN_NAME}; \
	done
	for PYTHON_VERSION in $(PYTHON_VERS) $(PYTHON3_VERS); do \
		$(RM) $(CURDIR)/uwsgi_python$${PYTHON_VERSION}; \
	done
	# intermediate compiled files
	find $(CURDIR) \
		\! -path '$(CURDIR)/debian/*' \( -name '*.o' -o -name '*.pyc' \) -type f \
		-delete
	find $(CURDIR) \
		\! -path '$(CURDIR)/debian/*' -name __pycache__ -type d \
		-delete
	# plugins
	for PLUGIN_NAME in $(UWSGI_PLUGINS_NAMES); do \
		$(RM) $(CURDIR)/$${PLUGIN_NAME}_plugin.so; \
	done
	for PYVER in $(PYTHON_VERS) $(PYTHON3_VERS); do \
		$(RM) \
			$(CURDIR)/greenlet_python$${PYVER}_plugin.so \
			$(CURDIR)/pyerl_python$${PYVER}_plugin.so \
			$(CURDIR)/python$${PYVER}_plugin.so; \
	done
	# compiled Apache2 modules
	$(RM) -r $(CURDIR)/apache2/.libs
	$(RM) -r $(addprefix $(CURDIR)/apache2/mod_, \
		$(foreach module_name, $(LIBAPACHE2_MODS_NAMES), \
			$(addprefix $(call libapache2mod_to_orig, $(module_name)), .la .lo .slo) \
	))
	# instantiated build configurations
	$(RM) $(CURDIR)/debian/buildconf/uwsgi-plugin.ini
	# staging directory of uwsgi-core documentation
	$(RM) -r $(UWSGI_CORE_DOCS_STAGING_DIR)
	# instantiated uwsgi-plugin-X templates
	$(RM) $(call files_instantiated_in_debian_dir, \
		uwsgi-plugin-, $(filter-out jwsgi-openjdk-6 jwsgi-openjdk-7, $(UWSGI_PLUGIN_PKGS_NAMES)), \
		.install \
	)
	for TEMPLATE_TYPE in links manpages postinst prerm; do \
		for INSTANTIATED_TEMPLATE in $(call files_instantiated_in_debian_dir, \
			uwsgi-plugin-, \
			$(ORDINARILY_BUILT_UWSGI_PLUGIN_PKGS) \
				lua5.1 rack-ruby1.8 rack-ruby1.9.1, \
			.$${TEMPLATE_TYPE} \
		); do \
			if [ -f $(CURDIR)/debian/uwsgi-plugin.$${TEMPLATE_TYPE}.in ]; then \
				$(RM) $${INSTANTIATED_TEMPLATE}; \
			fi; \
		done; \
	done
	for TEMPLATE_TYPE in dirs links manpages postinst prerm; do \
		$(RM) $(call files_instantiated_in_debian_dir, \
			uwsgi-plugin-, $(UWSGI_PLUGIN_PYTHON_PKG_KINDS), .$${TEMPLATE_TYPE} \
		); \
		$(RM) $(call files_instantiated_in_debian_dir, \
			uwsgi-plugin-pyerl-, \
			$(UWSGI_PLUGIN_PYTHON_PKG_KINDS), .$${TEMPLATE_TYPE} \
		); \
	done
	for TEMPLATE_TYPE in postinst prerm; do \
		$(RM) $(call files_instantiated_in_debian_dir, \
			uwsgi-plugin-greenlet-, \
			$(UWSGI_PLUGIN_PYTHON_PKG_KINDS), .$${TEMPLATE_TYPE} \
		); \
	done
	for TEMPLATE_TYPE in links manpages; do \
		$(RM) $(CURDIR)/debian/uwsgi-plugin-jvm-openjdk-6.$${TEMPLATE_TYPE}; \
		$(RM) $(CURDIR)/debian/uwsgi-plugin-jvm-openjdk-7.$${TEMPLATE_TYPE}; \
	done
	# instantiated libapache2-mod-X templates
	for TEMPLATE_TYPE in $(LIBAPACHE2_MOD_PKG_TEMPLATES); do \
		$(RM) $(call files_instantiated_in_debian_dir, \
			libapache2-mod-, $(LIBAPACHE2_MODS_NAMES), .$${TEMPLATE_TYPE} \
		); \
	done
	$(RM) $(addprefix $(CURDIR)/debian/, \
		$(foreach module_name, $(LIBAPACHE2_MODS_NAMES), \
			$(addsuffix .load,  $(call libapache2mod_to_orig, $(module_name))) \
	))
	# generated manpages
	$(RM) $(CURDIR)/debian/uwsgi-core.1
	$(RM) $(call files_instantiated_in_debian_dir, \
		uwsgi_, $(UWSGI_PLUGINS_NAMES), .1 \
	)
	$(RM) $(call files_instantiated_in_debian_dir, \
		uwsgi_python, $(PYTHON_VERS) $(PYTHON3_VERS), .1 \
	)
	# stampfiles
	$(RM) $(CURDIR)/debian/stamp-*
	$(RM) $(CURDIR)/uwsgibuild.*

# uwsgi package
# -------------

binary-post-install/uwsgi::

## uwsgi 1.9.17.1

=== Makefile ===
all:
	python uwsgiconfig.py --build

clean:
	python uwsgiconfig.py --clean

check:
	python uwsgiconfig.py --check

=== debian/changelog ===
uwsgi (1.9.17.1-5build5) trusty; urgency=medium

  * No-change rebuild to drop Python 3.3 support.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 23 Mar 2014 15:28:12 +0000

uwsgi (1.9.17.1-5build4) trusty; urgency=medium

  * Rebuild for Python 3.4.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 19 Feb 2014 20:55:38 +0100

uwsgi (1.9.17.1-5build3) trusty; urgency=medium

  * No change rebuild for phpapi-20121212+lfs (LFS ABI break on 32-bit
    arches).

 -- Robie Basak <robie.basak@ubuntu.com>  Wed, 19 Feb 2014 08:24:52 +0000

uwsgi (1.9.17.1-5build2) trusty; urgency=medium

  * Rebuild again, the previous build was still linked against old gloox
    on some archs.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Fri, 31 Jan 2014 20:23:50 +0400

uwsgi (1.9.17.1-5build1) trusty; urgency=medium

  * No-change rebuild for gloox transition (LP: #1273967).

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 29 Jan 2014 22:50:19 +0400

uwsgi (1.9.17.1-5) unstable; urgency=low

  * Fix extend patch 1006 to avoid more IA64 clone() calls. Tidy DEP3
    patch header.
  * Fix extend patch 1007 to cover more linkage.
  * Unfuzz patch 2001.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 27 Sep 2013 01:53:54 +0200

uwsgi (1.9.17.1-4) unstable; urgency=low

  * Add patch 1006 to not use of clone() in emperor plugin on IA64, as
    workaround for FTBFS. Replaces previous unsuccesful patch 1006.
  * Add patch 1007 to fix linkage for GNU/Hurd and GNU/kFreeBSD.
  * Unfuzz patch 2001.
  * Stop needlessly build-depending explicitly on libbsd-dev.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 26 Sep 2013 22:11:34 +0200

uwsgi (1.9.17.1-3) unstable; urgency=low

  * Build-depend on libzm-dev as fallback for libzmq3-dev, to ease
    backporting.
  * Tighten uwsgi-plugin-php to depend on current or newer
    libphp5-embed: lack stable API/ABI.
    Tighten to depend on same libphp5-embed when building against older
    php5: SONAME always changed, so backports need rebuilding when php5
    is binNMU'ed.
  * Fix build-depend on libbsd-dev on KFreeBSD.
  * Add patch 1006 to include sched.h with GNU extensions, hopefully
    fixing FTBFS on IA64.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 26 Sep 2013 03:38:41 +0200

uwsgi (1.9.17.1-2) unstable; urgency=low

  * Add patches 4b60307 and b190744 cherry-picked from upstream VCS, to
    support KFreeBSD. Drop similar locally created patch 1006.
  * Unfuzz patches.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 25 Sep 2013 10:39:10 +0200

uwsgi (1.9.17.1-1) unstable; urgency=low

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Add patch 1006 to detect KFreeBSD.
  * Build-depend on libjail-dev and libkvm-dev on KFreeBSD.
  * Build-depend on libzmq3-dev (not libzmq-dev), and include KFreebsd
    (leaving out only Hurd).
  * Fix exclude building plugin emperor_zeromq on Hurd, and no longer
    exclude on KFreeBSD.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 25 Sep 2013 04:23:38 +0200

uwsgi (1.9.17-1) unstable; urgency=low

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Add patch 2001 to compile verbosely.
  * Fix adjust uwsgi-core buildconf to autodetect presence of libzmq.
  * Have apache2 modules only depend on api package when api is
    resolved, to ease backporting.
  * Update source paths for example files, and stop installing files now
    treated as tests.
  * Unfuzz patches.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 24 Sep 2013 06:10:50 +0200

uwsgi (1.9.16-2) unstable; urgency=low

  * Relax build-dependency on apache2-dev to be unversioned: Declared
    version satisfied by all releases ever made officially for Debian.
    Add apache2-threaded-dev as fallback, to ease backporting.
  * Tidy rules and control files:
    + Use CDBS_DEPENDS_* for binary package relations.
    + Resolve Python versions supported by this project (not all
      versions supported by target host - which is semantically
      different even though currently produces same result).
    + Drop unused variables PYTHON_MAJOR_VER and PYTHON3_MAJOR_VER.
    + Fix use unversioned Python binary when default version, to comply
      with Debian Python Policy §§ 1.4.1, 1.4.2.
    + Simplify Python module install, using CDBS python-module.mk.
    + Convert Python 2.x module to Python 3 during build (not install).
    + Simplify installation of plain files.
  * Fix Vcs-Browser URL.
    Closes: bug#723016. Thanks to Matthijs.
  * Update patches:
    + Merge together as patch 1001 the 2 patches that strips setting
      LD_RUN_PATH in LDFLAGS.
    + Prefix remaining patches with a number.
    + Add README in patch dir documenting numbering micro-policy.
    + Add patch 1006 to link dynamically against libperl.
  * Fix limit build-dependency on libzmq-dev to exclude the Hurd (in
    addition to kFreeBSD, but for different reason - libzmq-dev is not
    in itself Linux-specific).

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 18 Sep 2013 18:08:16 +0200

uwsgi (1.9.16-1) unstable; urgency=low

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Fix use packaging section httpd for libapache2-mod-uwsgi and
    libapache2-mod-ruwsgi.
  * Auto-resolve openjdk6-supported architectures.
  * Exclude build-dependency on libzmq-dev for kfreebsd-any, and avoid
    building module zeromq there.
  * Unfuzz patches.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 15 Sep 2013 12:43:52 +0200

uwsgi (1.9.15-1) experimental; urgency=low

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Auto-resolve V8- and greenlet-supported architectures.
    Relax arch-specific package relations:
    + For V8 include kfreebsd-* and mipsel.
    + For greenlet include all except ia64.
  * Update patches:
    + Drop patches applied upstream:
      - 000000_01_adjust_lua_plugin_buildscript.patch
      - alarm_speech-flags.patch
    + Drop patch no longer applying (one example script dropped
      upstream, another now treated as a test script):
      - 000000_04_strip_uwsgi_shebang_from_examples.patch


=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: web
 Priority: extra
 Maintainer: Janos Guljas <janos@debian.org>
+Uploaders: Jonas Smedegaard <dr@jones.dk>
 Build-Depends:
  cdbs,
  debhelper (>= 8),
- apache2-dev (>> 2.4~),
+ apache2-dev | apache2-threaded-dev,
  erlang-dev,
  help2man,
  javahelper,
@@ -14,6 +15,7 @@
  libjansson-dev,
  libldap2-dev,
  liblua5.1-0-dev,
+ liblua5.2-dev,
  libperl-dev,
  libpq-dev,
  libcurl4-openssl-dev,
@@ -22,7 +24,7 @@
  libsqlite3-dev,
  libxml2-dev,
  libyaml-dev,
- libzmq-dev,
+ libzmq3-dev [!hurd-any] | libzmq-dev [!kfreebsd-any !hurd-any],
  libphp5-embed,
  php5-dev,
  libonig-dev,
@@ -34,24 +36,26 @@
  libgnustep-base-dev,
  libcoro-perl,
  libgeoip-dev,
- libv8-dev [amd64 armel armhf i386],
+ libv8-dev [amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel],
  libxslt1-dev,
+ libcap-dev [linux-any],
+ libmatheval-dev,
+ libjail-dev [kfreebsd-any],
+ libkvm-dev [kfreebsd-any],
  pkg-config,
  python,
  python-all-dev,
- python-greenlet-dev [amd64 i386 mips powerpc s390],
+ python-greenlet-dev [amd64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc s390 s390x sparc],
  python3-all-dev,
- openjdk-6-jdk,
- openjdk-7-jdk,
- ruby1.8,
- ruby1.8-dev,
+ openjdk-6-jdk [amd64 armel armhf i386 ia64 mips mipsel powerpc s390 s390x sparc],
+ openjdk-7-jdk [amd64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc s390 s390x sparc],
  ruby1.9.1,
  ruby1.9.1-dev,
  uuid-dev
 Standards-Version: 3.9.4
 Homepage: http://projects.unbit.it/uwsgi/
 Vcs-Git: git://anonscm.debian.org/collab-maint/uwsgi.git
-Vcs-Browser: http://anonscm.debian.org/?p=collab-maint/uwsgi.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/uwsgi.git
 
 Package: uwsgi
 Architecture: any
@@ -170,7 +174,7 @@
     - coroae
     - echo
     - emperor_amqp
-    - emperor_zeromq
+    - emperor_zeromq (on supported architectures)
     - fastrouter
     - http
     - logfile
@@ -236,9 +240,9 @@
 Depends: ${misc:Depends},
  uwsgi-infrastructure-plugins (= ${binary:Version}),
  uwsgi-app-integration-plugins (= ${binary:Version}),
+ uwsgi-plugin-rbthreads (= ${binary:Version}),
  uwsgi-plugin-fiber (= ${binary:Version}),
- uwsgi-plugin-greenlet-python (= ${binary:Version})
-   [amd64 i386 mips powerpc s390],
+ uwsgi-plugin-greenlet-python (= ${binary:Version}) [amd64 armel armhf hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 mips mipsel powerpc s390 s390x sparc],
  uwsgi-plugin-php (= ${binary:Version}),
  uwsgi-plugin-pyerl-python (= ${binary:Version}),
  uwsgi-plugin-pyerl-python3 (= ${binary:Version})
@@ -291,18 +295,18 @@
 Architecture: any
 Depends: ${misc:Depends},
  uwsgi-plugin-erlang (= ${binary:Version}),
- uwsgi-plugin-jvm-openjdk-6 (= ${binary:Version}),
- uwsgi-plugin-jvm-openjdk-7 (= ${binary:Version}),
- uwsgi-plugin-jwsgi-openjdk-6 (= ${binary:Version}),
- uwsgi-plugin-jwsgi-openjdk-7 (= ${binary:Version}),
+ uwsgi-plugin-jvm-openjdk-6 (= ${binary:Version}) [amd64 armel armhf i386 ia64 mips mipsel powerpc s390 s390x sparc],
+ uwsgi-plugin-jvm-openjdk-7 (= ${binary:Version}) [amd64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc s390 s390x sparc],
+ uwsgi-plugin-jwsgi-openjdk-6 (= ${binary:Version}) [amd64 armel armhf i386 ia64 mips mipsel powerpc s390 s390x sparc],
+ uwsgi-plugin-jwsgi-openjdk-7 (= ${binary:Version}) [amd64 armel armhf i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc s390 s390x sparc],
  uwsgi-plugin-lua5.1 (= ${binary:Version}),
+ uwsgi-plugin-lua5.2 (= ${binary:Version}),
  uwsgi-plugin-php (= ${binary:Version}),
  uwsgi-plugin-psgi (= ${binary:Version}),
  uwsgi-plugin-python (= ${binary:Version}),
  uwsgi-plugin-python3 (= ${binary:Version}),
- uwsgi-plugin-rack-ruby1.8 (= ${binary:Version}),
  uwsgi-plugin-rack-ruby1.9.1 (= ${binary:Version}),
- uwsgi-plugin-v8 (= ${binary:Version}) [amd64 armel armhf i386]
+ uwsgi-plugin-v8 (= ${binary:Version}) [amd64 armel armhf i386 kfreebsd-amd64 kfreebsd-i386 mipsel]
 Description: plugins for integration of uWSGI and application
  uWSGI presents a complete stack for networked/clustered web applications,
  implementing message/object passing, caching, RPC and process management.
@@ -315,11 +319,11 @@
    * Erlang
    * Java (OpenJDK 6 and 7)
    * JWSGI (OpenJDK 6 and 7)
-   * Lua WSAPI (Lua 5.1)
+   * Lua WSAPI (Lua 5.1 and 5.2)
    * PHP
    * Perl PSGI
    * Python WSGI (Python/Python 3)
-   * Rack (Ruby 1.8/Ruby 1.9.1)
+   * Rack (Ruby 1.9.1)
    * V8
 
 Package: uwsgi-plugin-alarm-curl
@@ -329,25 +333,3 @@
  uWSGI presents a complete stack for networked/clustered web applications,
  implementing message/object passing, caching, RPC and process management.
  It is designed to be fully modular. This means that different plugins can be
- used in order to add compatibility with tons of different technology on top of
- the same core.
- .
- This package provides alarm_curl plugin for uWSGI.
-
-Package: uwsgi-plugin-alarm-xmpp
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, uwsgi-core (= ${binary:Version})
-Description: Alarm XMPP plugin for uWSGI
- uWSGI presents a complete stack for networked/clustered web applications,
- implementing message/object passing, caching, RPC and process management.
- It is designed to be fully modular. This means that different plugins can be
- used in order to add compatibility with tons of different technology on top of
- the same core.
- .
- This package provides alarm_xmpp plugin for uWSGI.
-
-Package: uwsgi-plugin-curl-cron
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, uwsgi-core (= ${binary:Version})
-Description: curl cron plugin for uWSGI
- uWSGI presents a complete stack for networked/clustered web applications,

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,26 @@
 #!/usr/bin/make -f
 
+include /usr/share/cdbs/1/rules/upstream-tarball.mk
+include /usr/share/cdbs/1/class/python-module.mk
 include /usr/share/cdbs/1/rules/debhelper.mk
+
+# resolve supported architectures for arch-varying build-dependencies
+# (in maintainer mode only: uses network and messes with control file)
+ifneq (,$(DEB_MAINTAINER_MODE))
+GREENLET_ARCHS := $(shell sh debian/pkgarchs.sh python-greenlet-dev)
+OPENJDK6_ARCHS := $(shell sh debian/pkgarchs.sh openjdk-6-jdk)
+OPENJDK7_ARCHS := $(shell sh debian/pkgarchs.sh openjdk-7-jdk)
+V8_ARCHS := $(shell sh debian/pkgarchs.sh libv8-dev)
+debian/control::
+	sed -i \
+		-e 's/@greenlet_archs@/$(GREENLET_ARCHS)/g' \
+		-e 's/@openjdk6_archs@/$(OPENJDK6_ARCHS)/g' \
+		-e 's/@openjdk7_archs@/$(OPENJDK7_ARCHS)/g' \
+		-e 's/@v8_archs@/$(V8_ARCHS)/g' \
+		debian/control
+endif
+
+DEB_UPSTREAM_URL = http://projects.unbit.it/downloads
 
 export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
@@ -10,43 +30,32 @@
 # Common variables
 # ================
 
-PYTHON=/usr/bin/python
 APXS2=/usr/bin/apxs2
 APR_CONFIG=/usr/bin/apr-config
 APU_CONFIG=/usr/bin/apu-config
 UWSGI_BUILDER = $(CURDIR)/uwsgiconfig.py
 APACHE2_API = $(shell perl -ne 'print $$1 if m/our\s+\$$API\s+=\s+"(.*)"/' < $(shell which dh_apache2))
 PHP_API = $(shell php-config --phpapi)
+# TODO: Drop this (and its use) when php5-embed ABI is stable in oldstable
+PHP_VERSION := $(shell dpkg-query -W -f '$${Version}' php5-dev)
+# TODO: Drop this (and its use) when php5 5.5.0+dfsg-13 is in oldstable
+PHP_SONAME_ALWAYS_CHANGE := $(shell dpkg --compare-versions '$(PHP_VERSION)' '>=' 5.5.0+dfsg-13~ || echo true)
 
 DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
 
-# Dotted versions of Python runtimes (like 'X.Y').
-PYTHON_VERS_DOTTED=$(shell pyversions -vs)
-PYTHON_DEFAULT_DOTTED=$(shell pyversions -dv)
-PYTHON3_VERS_DOTTED=$(shell py3versions -vs)
-PYTHON3_DEFAULT_DOTTED=$(shell py3versions -dv)
-
 # Dotless versions of Python runtimes (like 'XY').
-PYTHON_VERS=$(subst .,,$(PYTHON_VERS_DOTTED))
-PYTHON_DEFAULT=$(subst .,,$(PYTHON_DEFAULT_DOTTED))
-PYTHON3_VERS=$(subst .,,$(PYTHON3_VERS_DOTTED))
-PYTHON3_DEFAULT=$(subst .,,$(PYTHON3_DEFAULT_DOTTED))
-
-PYTHON_MAJOR_VER := 2
-PYTHON3_MAJOR_VER := 3
-
-# Standard directories, where dh_pythonX helper looking for Python modules.
-# Note: path is provided in debhelper format (without leading slash).
-PYTHON_DIST_PACKAGES_DIR = usr/lib/python$(PYTHON_DEFAULT_DOTTED)/dist-packages
-PYTHON3_DIST_PACKAGES_DIR = usr/lib/python3/dist-packages
+PYTHON_VERS=$(subst .,,$(cdbs_python_supported_versions))
+PYTHON_DEFAULT=$(subst .,,$(cdbs_python_current_version))
+PYTHON3_VERS=$(subst .,,$(cdbs_python3_supported_versions))
+PYTHON3_DEFAULT=$(subst .,,$(cdbs_python3_current_version))
+
+# Python install path for dh_install, as expected by dh_pythonX helpers
+# * major and minor included for python 2.x, else only major
+# * leading slash emitted
+python_installdir = usr/lib/$(or $(cdbs_curpythonstem:%=python%),$(cdbs_curpythonpribinary))/dist-packages
 
 # Search in debian/control for packages with name $(1)% and extract % in list.
-list_pkgname_suffixes = $(strip \
-	$(shell \
-		grep "^Package: $(1)" $(CURDIR)/debian/control \
-		| sed 's/Package: $(1)//' \
-	) \
-)
+list_pkgname_suffixes = $(patsubst $(1)%,%,$(filter $(1)%,$(DEB_PACKAGES)))
 
 # Transform plugin's package name to plugin's name:
 # * delete dots
@@ -72,10 +81,10 @@
 	$(UWSGI_PLUGIN_PYTHON_PKG_KINDS) \
 	greenlet-python \
 	jvm-openjdk-6 jwsgi-openjdk-6 \
-	lua5.1 \
+	lua5.1 lua5.2 \
 	jvm-openjdk-7 jwsgi-openjdk-7 \
 	$(patsubst %,pyerl-%,$(UWSGI_PLUGIN_PYTHON_PKG_KINDS)) \
-	rack-ruby1.8 rack-ruby1.9.1 fiber
+	rack-ruby1.9.1 rbthreads fiber
 
 ORDINARILY_BUILT_UWSGI_PLUGIN_PKGS := $(filter-out \
 	$(PARTICULARLY_BUILT_UWSGI_PLUGIN_PKGS), $(UWSGI_PLUGIN_PKGS_NAMES))
@@ -117,13 +126,19 @@
 
 DEB_INSTALL_DOCS_ALL += $(DEB_SRCDIR)/CONTRIBUTORS
 
+DEB_DH_INSTALL_ARGS_python-uwsgidecorators = uwsgidecorators.py $(python_installdir)
+DEB_DH_INSTALL_ARGS_python3-uwsgidecorators = 2to3/uwsgidecorators.py $(python_installdir)
+
 DEB_DH_SHLIBDEPS_ARGS_uwsgi-plugin-php = -l/usr/lib/php5 -- --ignore-missing-info
 
-DEB_DH_GENCONTROL_ARGS_uwsgi-plugin-php = -- -Vuwsgi:php:Depends="phpapi-$(PHP_API)"
-
-DEB_DH_GENCONTROL_ARGS_libapache2-mod-proxy-uwsgi = -- -Vuwsgi:apache2:Depends="apache2-api-$(APACHE2_API)"
-DEB_DH_GENCONTROL_ARGS_libapache2-mod-uwsgi = -- -Vuwsgi:apache2:Depends="apache2-api-$(APACHE2_API)"
-DEB_DH_GENCONTROL_ARGS_libapache2-mod-ruwsgi = -- -Vuwsgi:apache2:Depends="apache2-api-$(APACHE2_API)"
+CDBS_DEPENDS_uwsgi-plugin-php = phpapi-$(PHP_API)
+CDBS_DEPENDS_uwsgi-plugin-php +=, $(if $(PHP_SONAME_ALWAYS_CHANGE),\
+	libphp5-embed (= $(PHP_VERSION)),\
+	libphp5-embed (>= $(PHP_VERSION)~))
+
+CDBS_DEPENDS_libapache2-mod-proxy-uwsgi = $(APACHE2_API:%=apache2-api-%)
+CDBS_DEPENDS_libapache2-mod-uwsgi = $(APACHE2_API:%=apache2-api-%)
+CDBS_DEPENDS_libapache2-mod-ruwsgi = $(APACHE2_API:%=apache2-api-%)
 
 # Rules
 # =====
@@ -137,6 +152,8 @@
 	for PYTHON_VERSION in $(PYTHON_VERS) $(PYTHON3_VERS); do \
 		$(RM) $(CURDIR)/uwsgi_python$${PYTHON_VERSION}; \
 	done
+	# converted Python modules
+	rm -rf 2to3
 	# intermediate compiled files
 	find $(CURDIR) \
 		\! -path '$(CURDIR)/debian/*' \( -name '*.o' -o -name '*.pyc' \) -type f \
@@ -173,7 +190,7 @@
 		for INSTANTIATED_TEMPLATE in $(call files_instantiated_in_debian_dir, \
 			uwsgi-plugin-, \
 			$(ORDINARILY_BUILT_UWSGI_PLUGIN_PKGS) \
-				lua5.1 rack-ruby1.8 rack-ruby1.9.1, \
+				lua5.1 lua5.2 rack-ruby1.9.1, \
 			.$${TEMPLATE_TYPE} \
 		); do \
 			if [ -f $(CURDIR)/debian/uwsgi-plugin.$${TEMPLATE_TYPE}.in ]; then \
@@ -194,35 +211,3 @@
 		$(RM) $(call files_instantiated_in_debian_dir, \
 			uwsgi-plugin-greenlet-, \
 			$(UWSGI_PLUGIN_PYTHON_PKG_KINDS), .$${TEMPLATE_TYPE} \
-		); \
-	done
-	for TEMPLATE_TYPE in links manpages; do \
-		$(RM) $(CURDIR)/debian/uwsgi-plugin-jvm-openjdk-6.$${TEMPLATE_TYPE}; \
-		$(RM) $(CURDIR)/debian/uwsgi-plugin-jvm-openjdk-7.$${TEMPLATE_TYPE}; \
-	done
-	# instantiated libapache2-mod-X templates
-	for TEMPLATE_TYPE in $(LIBAPACHE2_MOD_PKG_TEMPLATES); do \
-		$(RM) $(call files_instantiated_in_debian_dir, \
-			libapache2-mod-, $(LIBAPACHE2_MODS_NAMES), .$${TEMPLATE_TYPE} \
-		); \
-	done
-	$(RM) $(addprefix $(CURDIR)/debian/, \
-		$(foreach module_name, $(LIBAPACHE2_MODS_NAMES), \
-			$(addsuffix .load,  $(call libapache2mod_to_orig, $(module_name))) \
-	))
-	# generated manpages
-	$(RM) $(CURDIR)/debian/uwsgi-core.1
-	$(RM) $(call files_instantiated_in_debian_dir, \
-		uwsgi_, $(UWSGI_PLUGINS_NAMES), .1 \
-	)
-	$(RM) $(call files_instantiated_in_debian_dir, \
-		uwsgi_python, $(PYTHON_VERS) $(PYTHON3_VERS), .1 \
-	)
-	# stampfiles
-	$(RM) $(CURDIR)/debian/stamp-*
-	$(RM) $(CURDIR)/uwsgibuild.*
-
-# uwsgi package
-# -------------
-
-binary-post-install/uwsgi::

=== debian/watch ===
version=3

# Upstream names tarball of:
# * beta as 'uwsgi-0.9.7-beta1.tar.gz'
# * RC as 'uwsgi-0.9.7-rc1.tar.gz'
# * release as 'uwsgi-0.9.7.tar.gz'
#
# uversionmangle recipe was found at
# http://lists.debian.org/debian-devel/2009/12/msg00503.html
# 
# uversionmangle is changed as upstream broke the pattern
opts=dversionmangle=s/\+dfsg// \
  http://projects.unbit.it/downloads/uwsgi-(\d[\d\.]+)\.tar\.gz debian uupdate
